//******************************************************************************
// -----------------------------------------------------------
// grattmoi.java
// -----------------------------------------------------------
//   Main class for grattmoi applet
// -----------------------------------------------------------
// Author : C. Caissotti
// E-Mail : ccaissotti@chez.com
// URL    : http://www.chez.com/ccaissotti
// -----------------------------------------------------------
// Ver  * Author     *  DATE    * Description
// ....................DD/MM/YY...............................
// 1.00 * C.CAISSOTTI  * 08/11/99 * Creation
//******************************************************************************
import java.applet.*;
import java.awt.*;
import java.net.URL;
import java.net.MalformedURLException;
import java.awt.event.MouseMotionListener;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.ActionEvent;
import java.util.BitSet;

//==============================================================================
// Main Class for applet ccalendar
//
//==============================================================================
public class grattmoi extends Applet implements Runnable, MouseMotionListener, ActionListener
{
	// THREAD SUPPORT:
	//		m_ccalendar	is the Thread object for the applet
	//--------------------------------------------------------------------------
	private Thread	 m_ccalendar = null;

	private Graphics Off_Graphic;
	private Image    Off_Image;
	private Graphics m_Graphics;
	private Image	 imBackground;
	private Image	 imForeground;
    public String sURL;	
    public String sForeground;	
    public String sBackground;	
    public String sTarget = "_blank";	
    public boolean bAffiche = false;
    public int aeffacer;
    public int efface;
    public int pourcent = 80;
    public int border = 0;
    int cx_gomme = 30;
    int cy_gomme = 20;
    Dimension d;
    BitSet points;
    Button b;

	MediaTracker tracker;
	//--------------------------------------------------------------------------
	public grattmoi()
	{
	}

	// APPLET INFO SUPPORT:
	//		The getAppletInfo() method returns a string describing the applet's
	// author, copyright date, or miscellaneous information.
    //--------------------------------------------------------------------------
	public String getAppletInfo()
	{
		return "Name: grattmoi\r\n" +
		       "Author: Caissotti\r\n" +
		       "JDK 1.1";
	}

	public void init()
	{
		String param;
        // If you use a ResourceWizard-generated "control creator" class to
        // arrange controls in your applet, you may want to call its
        // CreateControls() method from within this method. Remove the following
        // call to resize() before adding the call to CreateControls();
        // CreateControls() does its own resizing.
        //----------------------------------------------------------------------

     d = getSize();
     b = new Button("?");
	 b.addActionListener(this);
     setLayout(null);
     b.setBounds( d.width -12, d.height - 12,12,12 );
     add(b);
	 param = getParameter("URL");
	 if ( param == null )
		sURL = "http://www.chez.com/ccaissotti";
	 else
		 sURL = param;
		 
    sForeground = getParameter("ForeGround");
    sBackground = getParameter("BackGround");
    param = getParameter("pourcent");
    if ( param != null )
      {
       pourcent = Integer.valueOf(param).intValue();
       if ( pourcent > 100 ) pourcent = 100;
      }
    param = getParameter("border");
    if ( param != null )
        {
         border = Integer.valueOf(param).intValue();
        }
    param = getParameter("target");
    if ( param != null )
      sTarget = param;
    addMouseMotionListener(this);
	}

	// ccalendar Paint Handler
	//--------------------------------------------------------------------------
	public void paint(Graphics g)
	{
		update(g);
	}
	
	public synchronized void update( Graphics g )
	{
		if ( bAffiche )
            g.drawImage(Off_Image,0,0,this);
		else
		    g.drawString("Loading...",0,getSize().height/2);
	}

	//		The start() method is called when the page containing the applet
	// first appears on the screen. The AppletWizard's initial implementation
	// of this method starts execution of the applet's thread.
	//--------------------------------------------------------------------------
	public void start()
	{
		if (m_ccalendar == null)
		{
			m_ccalendar = new Thread(this);
			m_ccalendar.start();
		}
	}
	
	//		The stop() method is called when the page containing the applet is
	// no longer on the screen. The AppletWizard's initial implementation of
	// this method stops execution of the applet's thread.
	//--------------------------------------------------------------------------
	public void stop()
	{
		if (m_ccalendar != null)
		{
			m_ccalendar.stop();
			m_ccalendar = null;
		}
	}

	// THREAD SUPPORT
	//		The run() method is called when the applet's thread is started. If
	// your applet performs any ongoing activities without waiting for user
	// input, the code for implementing that behavior typically goes here. For
	// example, for an applet that performs animation, the run() method controls
	// the display of images.
	//--------------------------------------------------------------------------
public void run()
{
    int i;
    int npoint;
	npoint = (d.width-border)*(d.height-border);
    points = new BitSet(npoint);
    aeffacer = npoint * pourcent / 100;
    efface = 0;
    for ( i = 0 ; i < npoint ; i++ )
        points.clear(i);
    tracker = new MediaTracker(this);
	repaint();
	// If an image list is in parameter, load the images here
	imBackground = getImage(getDocumentBase(), sBackground);
	tracker.addImage(imBackground, 0);
	imForeground = getImage(getDocumentBase(), sForeground);
	tracker.addImage(imForeground, 0);

	try
		{
		tracker.waitForID(0);
		if ( tracker.isErrorAny() )
			{
		    m_Graphics.drawString("Error loading image...",0,0);
			stop();
			return;
			}
		}
		catch (InterruptedException e)
			{
		    m_Graphics.drawString("Error loading image... ",0,0);
			stop();
			return;
			}
	try
		{
		Off_Image = createImage( d.width,d.height );
		Off_Graphic = Off_Image.getGraphics();							   
		}
	catch( Exception e )
		{
		}
    // La premire image doit remplir compltement l'applet
    Off_Graphic.drawImage(imForeground, 0, 0, d.width, d.height, this );
    bAffiche = true;
    repaint();
}

public void mouseDragged(MouseEvent me)
{
    int ly;
    int lx;
    int x = me.getX();
    int y = me.getY();
    if ( y < 0 || x < 0 || !bAffiche ) return;
    int i = (y-border) * d.width + x - border;
    setCursor( new Cursor(Cursor.HAND_CURSOR));
    Off_Graphic.drawImage( imBackground, x, y, x+cx_gomme, y+cy_gomme,x, y, x+cx_gomme, y+cy_gomme,this );
    repaint();
    if ( y < border || x < border || y > d.height - border || x > d.width - border ) return;
    // La taille de la souris est de 10 sur 20 on calcul donc les points effacs
    for ( ly = 0 ; ly < cy_gomme ; ly++ )
    {
        for ( lx = 0 ; lx < cx_gomme ; lx++ )
        {
            if ( !points.get(i+lx) )
              {
                points.set(i+lx);
                efface++;
              }
        }
        i+=d.width;
    }
 if ( efface >= aeffacer && efface < d.height * d.width )
    {
            efface = d.height * d.width;
			try
			{
	          getAppletContext().showDocument(new URL( sURL),sTarget);
			}
			catch ( MalformedURLException e)
			{
			}
	}
 
}


public void mouseMoved(MouseEvent e)
{
 setCursor( new Cursor(Cursor.DEFAULT_CURSOR));
}

public void actionPerformed( ActionEvent a )
{
			try
			{
	          getAppletContext().showDocument(new URL("http://www.chez.com/ccaissotti/java/scratch.htm"),"_top");
			}
			catch ( MalformedURLException e)
			{
			}
}

}
